SystemOrganization addCategory: #ConfigurationOfCPanel!

Object subclass: #ConfigurationOfCPanel
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCPanel'!

!ConfigurationOfCPanel class methodsFor: 'development support' stamp: 'SeanDeNigris 7/14/2015 13:16'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCPanel class methodsFor: 'private' stamp: 'SeanDeNigris 7/14/2015 13:16'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCPanel class methodsFor: 'private' stamp: 'SeanDeNigris 7/14/2015 13:16'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCPanel class methodsFor: 'private' stamp: 'SeanDeNigris 7/14/2015 13:16'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCPanel class methodsFor: 'metacello tool support' stamp: 'SeanDeNigris 7/14/2015 13:16'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCPanel class methodsFor: 'loading' stamp: 'SeanDeNigris 7/14/2015 13:16'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCPanel class methodsFor: 'loading' stamp: 'SeanDeNigris 7/14/2015 13:16'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCPanel class methodsFor: 'loading' stamp: 'SeanDeNigris 7/14/2015 13:16'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCPanel class methodsFor: 'accessing' stamp: 'SeanDeNigris 7/14/2015 13:16'!
project

	^self new project! !

!ConfigurationOfCPanel class methodsFor: 'development support' stamp: 'SeanDeNigris 7/14/2015 13:16'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCPanel methodsFor: 'baselines' stamp: 'SeanDeNigris 8/6/2015 18:12'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/SeanDeNigris/CPanel/main/'.
		spec 
			project: 'NeoJSON' with: [
				spec
					className: #ConfigurationOfNeoJSON;
					versionString: #'stable';
					repository: 'http://mc.stfx.eu/Neo' ];
			project: 'BabyPhexample' with: [
				spec
					className: #ConfigurationOfBabyPhexample;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo40/main/' ];
			project: 'Magritte3' with: [
				spec
					className: #ConfigurationOfMagritte3;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Magritte/Magritte3/main/' ].
		spec package: 'CPanel' with: [
				spec requires: #('NeoJSON' 'BabyPhexample' 'Magritte3' ). ]. ].
! !

!ConfigurationOfCPanel methodsFor: 'accessing' stamp: 'SeanDeNigris 7/14/2015 13:16'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfCPanel methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 8/6/2015 18:19'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfCPanel methodsFor: 'accessing' stamp: 'SeanDeNigris 7/14/2015 13:16'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCPanel methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 8/6/2015 18:19'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfCPanel methodsFor: 'versions' stamp: 'SeanDeNigris 8/6/2015 18:21'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: '[FEATURE]: CPanel login
	- See CPanelLogin class for API
	- GUI available from the world menu'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '8/6/2015 18:19'.
		spec 
			project: 'NeoJSON' with: '10';
			project: 'BabyPhexample' with: '1.0.1';
			project: 'Magritte3' with: '3.4.2'.
		spec package: 'CPanel' with: 'CPanel-SeanDeNigris.5'. ].
! !
